package cz.muni.fi.pa165.ejb;

import java.util.Arrays;
import java.util.List;
import java.util.logging.Logger;
import javax.interceptor.AroundInvoke;
import javax.interceptor.InvocationContext;

public class LoggingInterceptor {

    private static Logger logger = Logger.getLogger(
            LoggingInterceptor.class.getName());

    @AroundInvoke
    public Object logMethodCall(InvocationContext invocationContext) throws Exception {
        String method = invocationContext.getMethod().getName();
        List<Object> parameters = Arrays.asList
                (invocationContext.getParameters());
        logger.severe("Method :" + method + 
                " called with parameters " + parameters);
        return invocationContext.proceed();
    } 
}
